<template>
	<view class="main">
		<view class="one">
			<input type="text" v-model="searchInfo.title" @input="toInput" placeholder="搜索标题">
		</view>
		<view class="two">
			<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage" @scroll="toScroll">
				<view class="list-scroll-view">
					<view class="list" v-for="(item, index) in list" :key="index" @tap="toInfo(item)">
						<view class="list_1">
							<view class="left">
								<image class="image"
									:src="item.doctor.icon&&item.doctor.icon.length>0?item.doctor.icon[0].url:config.user_url[0].url"
									mode="">
								</image>
								<text>{{item.doctor.name||'暂无'}}</text>
							</view>
							<view class="right">{{item.create_time||'暂无'}}</view>
						</view>
						<view class="list_2">
							<image class="image" :src="item.img_url&&item.img_url.length>0?item.img_url[0].url:''"
								mode="">
							</image>
						</view>
						<view class="list_3">
							<text>{{item.title||'暂无标题'}}</text>
						</view>
					</view>
					<view class="is_bottom" v-if="is_bottom">
						<text>{{config.bottom_title||'到底了！'}}</text>
					</view>
				</view>
			</scroll-view>
		</view>
	</view>
</template>

<script>
	export default {
		data() {
			return {
				config: {},
				user: {},
				searchInfo: {},
				list: [],
				total: 0,
				skip: 0,
				limit: 5,
				page: 0,
				// 数据是否触底
				is_bottom: false,
				scrollTop: 0,
			}
		},
		onLoad: async function(e) {
			const that = this;
			that.searchToken();
			that.searchConfig();
		},
		onShow: async function() {
			const that = this;
			that.clearPage();
			await that.search();
		},
		onPullDownRefresh: async function() {
			const that = this;
			that.clearPage();
			await that.search();
			uni.stopPullDownRefresh();
		},
		methods: {
			// 用户信息
			searchToken() {
				const that = this;
				try {
					const res = uni.getStorageSync('token');
					if (res) {
						const user = that.$jwt(res);
						that.$set(that, `user`, user);
					}
				} catch (e) {}
			},
			searchConfig() {
				const that = this;
				try {
					const res = uni.getStorageSync('config');
					if (res) that.$set(that, `config`, res);
				} catch (e) {}
			},
			async search() {
				const that = this;
				let info = {
					skip: that.skip,
					limit: that.limit,
					is_use: '0'
				}
				const res = await that.$api(`/article`, 'GET', {
					...info,
					...that.searchInfo
				})
				if (res.errcode == '0') {
					let list = [...that.list, ...res.data];
					that.$set(that, `list`, list)
					that.$set(that, `total`, res.total)
				} else {
					uni.showToast({
						title: res.errmsg,
						icon: 'none'
					});
				}
			},
			// 输入框
			toInput(e) {
				const that = this;
				if (that.searchInfo.title) that.$set(that.searchInfo, `title`, e.detail.value)
				else that.$set(that, `searchInfo`, {})
				that.clearPage();
				that.search();
			},
			// 查看详情
			toInfo(item) {
				uni.navigateTo({
					url: `/pagesScience/science/index?id=${item.id||item._id}&title=${item.title}`
				})
			},
			// 分页
			toPage(e) {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();
				} else that.$set(that, `is_bottom`, true)
			},
			toScroll(e) {
				const that = this;
				let up = that.scrollTop;
				that.$set(that, `scrollTop`, e.detail.scrollTop);
				let num = Math.sign(up - e.detail.scrollTop);
				if (num == 1) that.$set(that, `is_bottom`, false);
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 5)
				that.$set(that, `page`, 0)
			}
		}
	}
</script>

<style lang="scss" scoped>
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			display: flex;
			justify-content: center;
			align-items: center;
			padding: 2vw;

			input {
				width: 100%;
				padding: 2vw;
				background-color: var(--f1Color);
				font-size: var(--font14Size);
				border-radius: 5px;
			}
		}

		.two {
			position: relative;
			flex-grow: 1;
			background-color: var(--f9Color);
			margin: 2vw 0 0 0;

			.list {
				background-color: var(--mainColor);
				border: 1px solid var(--f5Color);
				padding: 2vw 0;
				margin: 2vw 2vw 0 2vw;
				border-radius: 10px;

				.list_1 {
					display: flex;
					justify-content: space-between;
					align-items: center;
					padding: 2vw;

					.left {
						display: flex;
						align-items: center;
						font-size: var(--font16Size);
						color: var(--f191Color);

						.image {
							width: 10vw;
							height: 10vw;
							border-radius: 10vw;
							margin: 0 2vw 0 0;
						}
					}

					.right {
						font-size: var(--font12Size);
						color: var(--f99Color);
					}
				}

				.list_2 {
					.image {
						width: 100%;
						height: 30vh;
					}
				}

				.list_3 {
					padding: 2vw;
					font-size: var(--font16Size);
				}
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		width: 100%;
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: var(--f85Color);
			font-size: var(--font14Size);
		}
	}
</style>